TOOL.Category		= "Constraints"
TOOL.Name			= "#Quick Weld"
TOOL.Command		= nil
TOOL.ConfigName		= ""

TOOL.ClientConVar["weld"] = 1
TOOL.ClientConVar["nocollide"] = 0

TOOL.SelectedProps = {}


if CLIENT then
	language.Add( "Tool_quickweld_name", "Quick Weld" )
	language.Add( "Tool_quickweld_desc", "Quickly weld props" )
	language.Add( "Tool_quickweld_0", "Primary: Select/Deselect Prop   Secondary: Process Props   Reload: Deselect All" )
	language.Add( "Tool_quickweld_set", "Quick Weld:" )
	language.Add( "Tool_quickweld_set_desc", "Quickly weld props" )
	language.Add( "Tool_quickweld_noneselected", "A prop must be selected first!" )
end

if SERVER and not Weights then Weights = {} end

function TOOL:SelectEnt(ent)
	local Prop = {}
	Prop.ent = ent
	Prop.r, Prop.g, Prop.b, Prop.a = ent:GetColor()
	table.insert(self.SelectedProps, Prop)
	ent:SetColor(255, 0, 0, 255)
end

function TOOL:UnSelectEnt(ent)
	for k, Prop in pairs(self.SelectedProps) do
		if(Prop.ent == ent) then
			Prop.ent:SetColor(Prop.r, Prop.g, Prop.b, Prop.a)
			table.remove(self.SelectedProps, k)
		end
	end
end

function TOOL:CheckEnt(ent)
	local FoundIt = false
	if(table.Count(self.SelectedProps) == 0) then
		return false
	end
	for k, Prop in pairs(self.SelectedProps) do
		if(Prop.ent == ent) then
			FoundIt = true
		end
	end
	return FoundIt
end

function TOOL:WeldAll()
	if not SERVER then return end

	if(table.Count(self.SelectedProps) > 0) then
		local weld	= self:GetClientNumber("weld")
		local nocollide	= self:GetClientNumber("nocollide")

		//We don't want to weld, nor nocollide. No sense in running through all this code.
		if (weld == 0 && nocollide == 0) then
			self:GetOwner():PrintMessage(HUD_PRINTCENTER, "No Collide and weld options are unchecked! Please check at least one of these in the menu.")
			return 
		end

		undo.Create("quickweld")
		for kone, vone in pairs(self.SelectedProps) do
			if(vone.ent:IsValid()) then
				for ktwo, vtwo in pairs(self.SelectedProps) do
					if(vtwo.ent:IsValid() && vtwo.ent != vone.ent) then
						if (weld == 1) then
							undo.AddEntity(constraint.Weld(vone.ent,vtwo.ent,0,0,0))
						end
						if (nocollide == 1) then
							undo.AddEntity(constraint.NoCollide(vone.ent,vtwo.ent,0,0,0))
						end
					end
				end
			end
		end
		if (weld == 1 && nocollide == 1) then
			self:GetOwner():PrintMessage(HUD_PRINTCENTER, "Props have been welded and no-collided!")
		elseif (weld == 1 && nocollide == 0) then
			
			self:GetOwner():PrintMessage(HUD_PRINTCENTER, "Props have been welded!")
		elseif (weld == 0 && nocollide == 1) then
			self:GetOwner():PrintMessage(HUD_PRINTCENTER, "Props have been no-collided!")
		end
		self:ClearSelectedProps()
		undo.SetPlayer(self:GetOwner())
		undo.Finish()
	end

	/*local CurrentPhys = Ent:GetPhysicsObject()
	if ( CurrentPhys:IsValid() ) then
		local constraint = constraint.Weld(SelectedProp,Ent,0,0,0)
		undo.Create("quickweld")
		undo.AddEntity(constraint)
		undo.SetPlayer(self:GetOwner())
		undo.Finish()
	end*/
end

function TOOL:ClearSelectedProps()
	if(table.Count(self.SelectedProps) > 0) then
		for k, v in pairs(self.SelectedProps) do
			if(v.ent:IsValid()) then
				v.ent:SetColor(v.r, v.g, v.b, v.a)
			end
		end
		self.SelectedProps = {}
		return true
	else
		return false
	end
end

function IsReallyValid(trace)
	if not trace.Entity:IsValid() then return false end
	if trace.Entity:IsPlayer() then return false end
	if SERVER and not trace.Entity:GetPhysicsObject():IsValid() then return false end
	return true
end

function TOOL:LeftClick(trace) //(De)select props
	if CLIENT and IsReallyValid(trace) then return true end
	if not IsReallyValid(trace) then return false end

	if self:CheckEnt(trace.Entity) then
		self:UnSelectEnt(trace.Entity)
	else
		self:SelectEnt(trace.Entity)
	end

	return true;
end

function TOOL:RightClick(trace) //Work
	if CLIENT then return true end

	self:WeldAll()

	return true;
end

function TOOL:Reload(trace) //Clear or reset
	self:ClearSelectedProps()
end

function TOOL:Holster()
	if(CLIENT) then return true end
	self:ClearSelectedProps()
end

function TOOL:Think()
	if CLIENT then return end;
	local pl = self:GetOwner()
	local wep = pl:GetActiveWeapon()
	if not wep:IsValid() or wep:GetClass() != "gmod_tool" or pl:GetInfo("gmod_toolmode") != "quickweld" then 
		ClearSelected()
		return
	end
	local trace = pl:GetEyeTrace()
	if not IsReallyValid(trace) then return end
end

function TOOL.BuildCPanel(cp)
	cp:AddControl( "Header", { Text = "#Tool_quickweld_name", Description	= "#Tool_quickweld_desc" }  )
	cp:AddControl("CheckBox", {Label = "Weld", Command = "quickweld_weld"})
	cp:AddControl("CheckBox", {Label = "No Collide", Command = "quickweld_nocollide"})
end






